﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using static CommunicationEvents;

public class Pendulum : Gadget
//Acts as a Pendulum starting at a Point
{
    public override void _Enable()
    {
        ActivateLineDrawing();
    }

    public override void _Hit(RaycastHit hit)
    {
        if (hit.transform.gameObject.layer == LayerMask.NameToLayer("Point"))
        {
            PointFact tempFact = StageStatic.stage.factState[hit.transform.GetComponent<FactObject>().URI] as PointFact;

            //Raycast downwoard
            if(Physics.Raycast(tempFact.Point, Vector3.down, out RaycastHit ground, Mathf.Infinity, this.SecondaryLayerMask.value))
            {
                FactManager.AddPointFact(ground);
            }
        }
    }

    protected override void _ActivateLineDrawing()
    {
        GadgetManager.LineRenderer.positionCount = 2;

        GadgetManager.LineRenderer.startWidth = 0.095f;
        GadgetManager.LineRenderer.endWidth = 0.095f;
    }

    //Updates the points of the Lines when baseLine was selected in LineMode
    protected override void _UpdateLineDrawing()
    {
        SetPosition(0, GadgetManager.Cursor.transform.position);

        //Raycast downwoard
        if (Physics.Raycast(GetPosition(0), Vector3.down, out RaycastHit ground, Mathf.Infinity, this.SecondaryLayerMask.value))
            SetPosition(1, ground.point);
        else
            SetPosition(1, GetPosition(0));
    }
}
